
;128
;fast 0,2,4,6
;+2b+3
;fast 0,2,1,3

;0 - спрайто выводилка кодом + спрайты
;2 - основная память
;4 - выводилка тайлов и тайлы сдвинутых
;6 - выводилка тайлов и тайлы не сдвинутые

BRD1=0;1
BRD2=0;2

START_LEVEL = 1;
DEFAULT_DEPACK_FLAG = 0

MUTE = 0
CHEAT = 0

CAMERA_X_DELTA = 4; насколько видно вперёд по иксу база была 0, сейчас 4, измеряется в точках

spritesPage = 0   ;sprites at 0
levelsPage = 7    ;packed levels in 7 page

;128+gray
mapPage1 = 4
mapPage2 = 6
musicPage = 1
dataPage = 3

mapPage1p3 = 1
mapPage2p3 = 3
musicPagep3 = 4
dataPagep3 = 6

;+2b +3
;mapPage1 = 1
;mapPage2 = 3
;musicPage = 4;
;dataPage = 6

SOUND_EXIT = 12
SOUND_HIDDEN = 8

GS_GAMEPLAY = 0 ;gameplay state
GS_LOADING = 1 ;loading level
GS_SHOW_LEVEL = 2 ;show level loop
GS_HIDE_LEVEL = 3 ;hide level loop
GS_READ_TEXT = 4; do text mode
GS_PAUSE = 5
GS_MENU = 6
GS_OUTRO = 7

GS_NULL = 255

;include macros
        include "include\macros.a80"

   device ZXSPECTRUM128

        org 16384
        incbin "gfx\ringo.scr"
	savebin "loader\scr.bin",16384,$-16384

   page dataPage
      org 49152
music2Packed:
         incbin "music\music2.tbk.zx5"              
music2PackedSize = $-music2Packed         
music3Packed:
         incbin "music\music3.tbk.zx5"              
music3PackedSize = $-music3Packed        
music4Packed:
         incbin "music\music4.tbk.zx5"              
music4PackedSize = $-music4Packed        

music0Packed: incbin "music\menu.tbk.zx5"   
music0PackedSize = $-music0Packed

        display "dataPage: ",/d,$
	savebin "loader\p3.bin",49152,$-49152

   page 7
   org 49152
   incbin "gfx\disclamer.scr"
   include "maps\maps.a80"   
   savebin "loader\p7.bin",49152,$-49152

   ;page 5
   ;org 49152
   ;incbin "gfx\bg.scr"

   page musicPage
   org 49152
   include "music\player.asm"
   block 256,0
music:  incbin "music\menu2.tbk"   
;music:  incbin "music\null.tbk"  
music1Packed: incbin "music\music1.tbk.zx5"   
music1PackedSize = $-music1Packed

 display "musicPage: ",/d,$
	savebin "loader\p1.bin",49152,$-49152


   page spritesPage
   org 49152
   include "include\sprites.a80"
   savebin "loader\p0.bin",49152,$-49152

   page 0
   org 24500
start:
    di      
    ld sp,24499
    xor a : out (254),a
    ei : call kempstonTest : ei

    ld b,0 : call pause              
    ;show second screen with disclamer
    ld a,24+7 : ld bc,#7ffd : ld (23388),a : out (c),a
    call waitAndClearScreens
    di
    call machineTest
    call restorePixels : call restorePixels2
    
    ld bc,#7ffd : ld a,(vMusicPage) : out (c),a           
    ld hl,music : call mus_init+3
    ld bc,#7ffd : ld a,16+0 : out (c),a
    ld hl,nullFrame : ld (intProc1+1),hl
    ld hl,mainInterrupt  : call IMON

    call initLoading    
   
    jp startGame

;===== FROM HERO CODE SINCE NO PLACE ANYMORE====
fireControls:
;check fire        
        ;call check
        ;call waitFireUp
        ld a,(showText+1) : or a : ret nz
        ld a,(hideText+1) : or a : ret nz
        ld a,(wasFireUp) : or a : ret z
        ;call checkFireButton        
        ld a,(fireKey) : or a : jp nz,tryPutBlock        
1:        
        ;ok, fire up - no fire pressed
        xor a : ld (fireFlag),a

        ret   

gameState:      db GS_LOADING
currentLevel:   db 0;START_LEVEL

pause:
        ld b,100
1:
        halt
        djnz 1b     
        ret        


playMusic:
        IF MUTE == 0
        ld bc,#7ffd : ld a,(vMusicPage) : out (c),a        
mus_proc:  call mus_play
        ENDIF
        ld bc,#7ffd : ld a,(restorePage) : out (c),a
        call AFXFRAME
        ret

        include "include\animations.a80"
        include "include\gameStates.a80"
        ;include "include\text.a80"
        include "include\enemies.a80"
        include "include\eGuns.a80"
        include "include\text.a80"
        include "include\math.a80"
        ;include "include\sound.a80"

        include "include\particles.a80"        
        ;include "sfx\ayfxacb.asm"
        include "sfx\ayfx.asm"
        ;        include "include\pause.a80"
        include "include\hud.a80"
        include "include\images.a80"
        include "include\fxs.a80"
         
             
depack:    
    ;include "dzx0_mega.asm"
    ;include "dzx0_std.asm"
    include "maps\dzx5_std.asm"             

;nullMusic:  incbin "music\null.tbk"           

;======== FREE TILL 31768 ======================

        display "pre 31768: ",/d,$

        org 32768
        include "include\map.a80"

        include "include\controls.a80"  

waitAndClearScreens:
       ld hl,23560         ; LAST K system variable.
       ld (hl),0           ; put null value there.
loop   ld a,(hl)           ; new value of LAST K.
       cp 0                ; is it still zero?
       jr z,loop           ; yes, so no key pressed.
    xor a : ld hl,49152+6144 : ld de,49152+6144+1 : ld bc,768-1 : ld (hl),a : ldir    
    xor a : ld hl,22528 : ld de,22528+1 : ld bc,768-1 : ld (hl),a : ldir
    ld a,16+0 : ld bc,#7ffd : ld (23388),a : out (c),a
    ret

;vMapPage1_24: db 4+24
vMapPage1: db 4+16

;vMapPage2_24: db 6+24
vMapPage2: db 6+16

vMusicPage: db 16+1
vdataPage: db 16+3

haveKempston:	db 0


   
doGameplay1:
        ;COPY BUFFER TO SCREEN AND REDRAW 63 TILES ON BG
        ld hl,topBorder2 : ld (intProc1+1),hl	            
        ;===============================================
        ld a,BRD1 : out (254),a    
        ld bc,#7ffd : ld a,16 : out (c),a   
        ld a,(showText+1) : or a : jr nz,1f
        ld a,(hideText+1) : or a : jr nz,1f
        call doEnemies
1:        
        call doSprites 
        call doCameraView              
        call doTilesAnimations            
        ld a,(showText+1) : or a : call nz,doText01
        ld a,(hideText+1) : or a : call nz,doClearText01       
        call doParts       
        call doHud

;
        jp frame1End

doGameplay2:
        ;если вылезем за фрейм то отработает пустой фрейм который просто попереключает строчки и вернётся из прерывания
        ld hl,emptyFrame : ld (intProc1+1),hl                    
        ;=================================================
        ld a,BRD1 : out (254),a
        ;simulate high load        
        ;ld bc,228*32 : call DELAY        
        ld bc,#7ffd : ld a,16 : out (c),a                                      
        call doFX
        call readControls        
        call doHero      
        ;do some electric gunz       
        ;SKIP GUNS AND PARTS IF SIGN
        ld a,(showText+1) : or a : jr nz,4f
        call doEGuns                
        call drawParts        
4:                
        call drawHud     
showText:       ld a,0 : or a : call nz,doText02     
hideText:       ld a,0 : or a : call nz,doText02             
        
        ;следующий фрейм
        ld hl,topBorder1 : ld (intProc1+1),hl	    

        jp frame2End



startGame:
	

mainLoop:
	;dup 50
	halt     
reMainLoop:             
;========================================            
        ld a,(gameState)
        cp GS_GAMEPLAY
        jp z,doGameplay1     
        cp GS_LOADING
        jp z,doLoading
        cp GS_SHOW_LEVEL
        jp z,doShowLevel1
        cp GS_HIDE_LEVEL
        jp z,doHideLevel2
        cp GS_MENU
        jp z,doMenu01
        cp GS_OUTRO
        jp z,doOutro01

;        cp GS_PAUSE
;        jp z,doPause1
;========================================
frame1End:
        xor a : out (254),a   
        halt   
;===============================================
        ld a,(gameState)
        cp GS_GAMEPLAY        
        jp z,doGameplay2
        cp GS_SHOW_LEVEL
        jp z,doShowLevel2
        cp GS_HIDE_LEVEL
        jp z,doHideLevel1
        cp GS_MENU
        jp z,doMenu02
        cp GS_OUTRO
        jp z,doOutro02
;        cp GS_PAUSE
;        jp z,doPause2
;===============================================        
frame2End:           
        xor a : out (254),a  
        
trap:	jp mainLoop
	
	include "include\ints.a80"
;zz        
        ;can remove 256bytes delta table :)
        include "include\camera.a80"             
;        display /d,$-zz
        include "include\hero.a80"                
        ;include "include\emptyFrame.a80"        
        ;include "include\renderTable.a80"        
        include "include\outro.a80"   

topBorder1:
        include "include\render.a80"
        
        jp renderTiles
tbSP:	ld sp,00000     

        jp playMusic        

        ;ret

topBorder2:        
        ld a,0 : out (254),a
        include "include\topBorder2.a80"
endTB2:
        jp playMusic
;        ret     

restorePage: db 16+0

       ; display /d,"attrb:" , $
        include "include\attrBuffer.a80"
   

;========FREE TILL 48640 ===============

	display /d,"pre 48640: ",$      

	savebin "loader\main.bin",start,$-start

	page mapPage1
	org 49152
        include "include\tiles1.a80"
	savebin "loader\p4.bin",49152,$-49152

        page mapPage2
	org 49152
        include "include\tiles2.a80"
	savebin "loader\p6.bin",49152,$-49152

        
      ;  db 1
	

        page 0
        IF (_ERRORS = 0)                                 		
			savetap "main.tap",start
			SHELLEXEC "main.tap"	
	ENDIF






